unsigned char file_finished;//0=currently playing; 1=file finished
unsigned int point_counter;
unsigned int pos_read,pos_write;

#define FIFO_LEN 660//

unsigned char FIFO[FIFO_LEN];

void read_fifo(void);
void play_file(void);

void play_file(void)
{
        unsigned int i;
        struct FRAME_RESULT *frame;
        
        file_finished=0;
        point_counter=0;
        pos_read=0;
        pos_write=0;
        
        while(i<(FIFO_LEN-1))//fill the buffer
                {
                if(++point_counter>total_points)
                        { 
                        frame=load_header();
                        if(!((frame->total_points) && (frame->frame_status)))
                                { 
                                file_finished=1;
                                goto end_fill;
                                };
                        point_counter=1;
                        total_points=(frame->total_points);
                        };
                load_point();
                FIFO[i]=x;
                FIFO[++i]=y;
                ++i;//Z
                ++i;                                
                };
end_fill:
        if(i>(FIFO_LEN-1))
                pos_write=0;
        else
                pos_write=(--i);
                        
        while(1)/// Loop until end of file////////
                {
                
                enable_TIM1_int();//enable read
                //while(!(pos_read ^ pos_write));
                while(pos_read == pos_write);
                if(++point_counter>total_points)//check if to load next frame
                        { 
                        frame=load_header();//load info about frame
                        if(!((frame->total_points) && (frame->frame_status)))
                                {//if end or bad file 
                                file_finished=1;
                                goto end_file;
                                };
                        point_counter=1;
                        total_points=(frame->total_points);
                        };
                load_point();//load next point from file
                FIFO[pos_write]=x;
                FIFO[++pos_write]=y;
                ++pos_write;//Z
                if((++pos_write)>(FIFO_LEN-1))//overflow check
                        pos_write=0;

                };//////////////////////////////
end_file:
        disable_TIM1_int();
}

///// Read value from FIFO buffer /////
///// This function is called from INT subroutine /////
void read_fifo(void)
{                        
        OCR0A=FIFO[pos_read];//X
        OCR0B=FIFO[++pos_read];//Y
        ++pos_read;//Z
        
        if((++pos_read)>(FIFO_LEN-1))//overflow checking
                pos_read=0;
                
        //if(!(pos_read ^ pos_write))// pos_read==pos_write
        if(pos_read == pos_write)
                disable_TIM1_int();
}